/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package com.youchain.basicdata.rest;

import com.youchain.annotation.AnonymousAccess;
import com.youchain.annotation.Log;
import com.youchain.basicdata.domain.Area;
import com.youchain.basicdata.domain.Point;
import com.youchain.basicdata.repository.AreaRepository;
import com.youchain.basicdata.repository.PointRepository;
import com.youchain.basicdata.service.AreaService;
import com.youchain.basicdata.service.PointService;
import com.youchain.basicdata.service.dto.AreaDto;
import com.youchain.basicdata.service.dto.AreaQueryCriteria;
import com.youchain.basicdata.service.dto.AreaSmallDto;
import com.youchain.basicdata.service.dto.PointDto;
import com.youchain.basicdata.service.mapstruct.AreaMapper;
import com.youchain.basicdata.service.mapstruct.PointMapper;
import com.youchain.modules.system.domain.Dept;
import com.youchain.modules.system.service.DeptService;
import com.youchain.modules.system.service.dto.DeptDto;
import com.youchain.modules.system.service.dto.DeptSmallDto;
import com.youchain.modules.system.service.mapstruct.DeptMapper;
import com.youchain.utils.BaseStatus;
import com.youchain.utils.UserUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.data.domain.Pageable;
import lombok.RequiredArgsConstructor;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.*;
import java.io.IOException;
import java.util.List;
import java.util.Objects;
import javax.servlet.http.HttpServletResponse;

/**
* @website https://eladmin.vip
* @author HJL
* @date 2023-08-14
**/
@Slf4j
@RestController
@RequiredArgsConstructor
@Api(tags = "area管理")
@RequestMapping("/api/area")
public class AreaController {

    private final AreaService areaService;
    private final PointService pointService;
    private final PointRepository pointRepository;
    private final AreaRepository areaRepository;

    @PostMapping("/getAreas")
    @Log("加载下拉框area")
    public ResponseEntity<Object> queryArea(@RequestBody(required=false)  String type){
        return new ResponseEntity<>(areaService.getAreas(type),HttpStatus.OK);
    }

    @Log("导出数据")
    @ApiOperation("导出数据")
    @GetMapping(value = "/download")
    @AnonymousAccess
    public void exportArea(HttpServletResponse response, AreaQueryCriteria criteria) throws Exception {
        areaService.download(areaService.queryAll(criteria), response);
    }

    @GetMapping
    @Log("查询area")
    @ApiOperation("查询area")
    @AnonymousAccess
    public ResponseEntity<Object> queryArea(AreaQueryCriteria criteria, Pageable pageable){
        return new ResponseEntity<>(areaService.queryAll(criteria,pageable),HttpStatus.OK);
    }

    @GetMapping(value = "/queryAreaList")
    @Log("查询queryAreaList")
    @ApiOperation("queryAreaList")
    @AnonymousAccess
    public ResponseEntity<Object> queryAreaList(AreaQueryCriteria criteria){
        return new ResponseEntity<>(areaService.queryAll(criteria),HttpStatus.OK);
    }

    @PostMapping
    @Log("新增area")
    @ApiOperation("新增area")
    @PreAuthorize("@el.check('super:man')")
    public ResponseEntity<Object> createArea(@Validated @RequestBody Area resources){
        resources.setDept(UserUtils.getDept());
        AreaDto areaDto=areaService.create(resources);
        Area area=areaRepository.getById(areaDto.getId());
        if(area.getBexb()){
            String pointCode = area.getCode()+"_ZC";
            Point point = pointRepository.findByCode(pointCode);
            if (point == null){
                point=pointService.createPoint(pointCode,BaseStatus.HCKW,area);
            }
            resources.setPointId(point.getId());
            resources.setPointCode(pointCode);
        }
        areaService.update(area);
        return new ResponseEntity<>(areaDto,HttpStatus.CREATED);
    }

    @PutMapping
    @Log("修改area")
    @ApiOperation("修改area")
    @PreAuthorize("@el.check('super:man')")
    public ResponseEntity<Object> updateArea(@Validated @RequestBody Area resources){
        if(resources.getBexb()) {
            String pointCode = resources.getCode() + "_ZC";
            Point point = pointRepository.findByCode(pointCode);
            if (point == null) {
                point=pointService.createPoint(pointCode,BaseStatus.HCKW,resources);
            }
            resources.setPointId(point.getId());
            resources.setPointCode(pointCode);
        }
        areaService.update(resources);
        return new ResponseEntity<>(HttpStatus.NO_CONTENT);
    }

    @DeleteMapping
    @Log("删除area")
    @ApiOperation("删除area")
    @PreAuthorize("@el.check('super:man')")
    public ResponseEntity<Object> deleteArea(@RequestBody Long[] ids) {
        areaService.deleteAll(ids);
        return new ResponseEntity<>(HttpStatus.OK);
    }
}